#ifndef UWATER_FRAME_FUNC_REPLAY_SY_H
#define	UWATER_FRAME_FUNC_REPLAY_SY_H

#include "sys_config.h"
#if PRODUCT_SY
#include "UWater_Frame_app.h"
/**************************************20211025Լ********************************************/
//ϱ
//ˮƽ̨ݹԼ
//ϴݣ101Ӧ1  ϱδݡˮ״̬Ϣ
#define FM_UPLOAD_FROZEN_DATA_CTRL                        0x65   //101     
#define FM_UPLOAD_FROZEN_DATA_REPLY_CTRL                  0x01   //1

//ϱ(102,Ӧ2)   ϱڲɼ
#define FM_UPLOAD_CYCLE_DATA_CTRL                         0x66   //102     
#define FM_UPLOAD_CYCLE_DATA_REPLY_CTRL                   0x02   //2

//ͻϴ(103,Ӧ3)   ڷȼΪ1ı¼ʱʱϴ
#define FM_SUDDEN_ALARM_UPLOAD_CTRL                       0x67   //103     
#define FM_SUDDEN_ALARM_UPLOAD_REPLY_CTRL                 0x03   //3

//ˮӦƽ̨Լ
//ã6Ӧ106   ϴʱ䡢طš
#define FM_PARAMENTER_SETTING_CTRL                        0x06   //6    
#define FM_PARAMENTER_SETTING_REPLY_CTRL                  0x6A   //106

//ѯ7Ӧ107   ڷȼΪ1ı¼ʱʱϴ
#define FM_PARAMENTER_QUERY_CTRL                          0x07   //7    
#define FM_PARAMENTER_QUERY_REPLY_CTRL                    0x6B   //107

//ݲѯ(8,Ӧ108)  ѯնݡ궳ݡ¶
#define FM_FROZEN_DATA_QUERY_CTRL                         0x08   //8    
#define FM_FROZEN_DATA_QUERY_REPLY_CTRL                   0x6C   //108

 //ݲѯ(9,Ӧ109)   ѯ7
#define FM_CYCLE_DATA_QUERY_CTRL                          0x09   //9    
#define FM_CYCLE_DATA_QUERY_REPLY_CTRL                    0x6D   //109

//ʷݲѯ10Ӧ110   ѯʷ
#define FM_ALARM_HISTORY_DATA_QUERY_CTRL                  0x0A   //10    
#define FM_ALARM_HISTORY_DATA_QUERY_REPLY_CTRL            0x6E   //110
  
//(51,Ӧ151)   նݡʷݡ
#define FM_CLEAR_ALL_DATA_CTRL                            0x33   //51    
#define FM_CLEAR_ALL_DATA_REPLY_CTRL                      0x97   //151

//ָ(52,Ӧ152)
#define FM_RESTORE_FACTORY_SETTING_CTRL                   0x34   //52    
#define FM_RESTORE_FACTORY_SETTING_REPLY_CTRL             0x98   //152

//ָ(71,Ӧ171)  ɳжıģɳ
#define FM_DEBUG_INSTRUCTION_CTRL                         0x47   //71   
#define FM_DEBUG_INSTRUCTION_REPLY_CTRL                   0xAB   //171

typedef union 
{
	struct 
	{
    u8 data0;
    u8 data1;
	} datas_map;
	u8 data_buf[2];
	u16 datas;
} SY_UNION_2U8TOU16;

typedef struct 
{
	u8 head_site; //֡ͷλ
	u8 ctrl;
	u8 ack_ctrl;
	SY_UNION_2U8TOU16 len;  //Լݳȹ̶2ֽ16ƣֽǰֽں
	u8 end_site; //֡βλ
	u8 check_len; //Уݳ
	u8 sta;  //GPRS״̬0x80  0x40 (BIT2 = 0Ӧ֡)
	u8 met_type;  //ԼͶΪԼͣΪ0X02
	u8 serial_num0;  //к
} STRUCT_FRAME_SY;//洢֡Ҫ


u8 up_deal_code_sy(void);
u8 crack_frame_SY(u16 frame_lenth,u8 *frame_buffer);
void Frame_ResetDealState_Shenyang(void);
void Sy_Frame_nb_read_ack(u8* p_send_buf, u16* p_send_len);
/************************************************ϱ**********************/
void GetUploadDataResetState_ShenYangUDP(void);
u8 GetUploadDataCheckIdle_ShenYangUDP(void);
u8 GetUploadDataCheckTask_ShenYangUDP(void);
void GetUploadDataMachine_ShenYangUDP(u8 data_step, u8* p_send_buf, u16* p_send_len);

/**************************洢غ***************************************/
void DataStoreInit(void);
void DataStoreMachine(void);
u8 DataStoreIfIdle(void);
/*****************************************************************************/
#define MAIN_CONNECT_TYPE      NBIOT_CONNECT_UDP1
#define MAIN_SEND_TYPE         SEND_TYPE_UDP1
#define SLAVE_CONNECT_TYPE     NBIOT_CONNECT_UDP2
#define SLAVE_SEND_TYPE        SEND_TYPE_UDP2
//ϱ10룬ϱ5
#define COAP_UPLOAD_WAIT_ACK_TIME  100   
#define UDP_UPLOAD_WAIT_ACK_TIME   50 
#define NB_ONLINE_KEEP_TIME  50


#endif

#endif	


