#ifndef _SYS_PROCESSOR_BLE_H_
#define	_SYS_PROCESSOR_BLE_H_

#include "sys_config.h"
#if UPLOAD_MODE_2
#include "type.h"
#include "UWater_rtcc_driver.h"
#pragma pack(1) //1ֽڶ


typedef struct
{
    u8 retry_num;             //ط
    u8 Step_send_report;//add by wm 2017.07.19 ϱ 1ϱ 2ܼϱ 3ǲ
    u8 Flag_Send_DATA;//add by wm 2017.07.19  ָ־ 1ǷͿʼ
    u8 Supplemental_send_NO;//ѯ̱ʾǰڲһ¼ڲͳɹҪü¼bit
    u8 Save_histroy_FLAG;
    u8 Save_histroy_step;
    u8 Read_histroy_FLAG;
}FRAME_SEND_CONTROL;

typedef enum
{
    NB_HistroyReadIndex = 0, //ʷݵĶָ
	NB_UploadFailTimes = 1,//ʧܴ
	NB_SendData_Msg = 2,//NBҪϢ
	NB_SS_FormatError = 3, //ݸʽ
} NB_SS_ControlParaTypeDef;

//ͳʱ
typedef union{
    struct{
        mtype32_ pulse_max_flow;			//
        mtype16_ pulse_continue_time;		//ʱ
        u8 pulse_flow_time[8];				//ʱ
        };
     u8 byte[14];   
}IES_PULSE_DAY_MAX_FLOW;	//

///**********************************************************ϱͶ**************************/
#define UPLOAD_TYPE_FIX_TIME     		0    			//0Զʱ 
#define UPLOAD_TYPE_HAND_KEY   		 	1	  			//1ֶ 
#define UPLOAD_TYPE_FRAME_ORDER        	2  				//2: Լϴ
#define UPLOAD_TYPE_RETRY_AGAIN    		3  				//3: ϴ
#define UPLOAD_TYPE_VALVE_CLOSE    		4  				//4: Źرϴ
#define UPLOAD_TYPE_VALVE_ACTIVE  		5  				//5: Ŷϴ
#define UPLOAD_TYPE_SET_IP     			6  				//6: IPϴ
#define UPLOAD_TYPE_TOUCH_KEY      		7  				//7: ϴ
#define UPLOAD_TYPE_WARNING      		8  				//8: ʱϴ
#define UPLOAD_TYPE_OTHER    	 		255  			//255
#define UPLOAD_EVENT_NUM         		10   			//ͬʱ֧10ϱ¼ 	

#define VALVE_CLOSE_UPLOAD_MAX          250             //طϱ
#define VALVE_CLOSE_UPLOAD_MIN			48              //طСϱ

typedef struct {
	u8 upload_type[UPLOAD_EVENT_NUM];
	u8 event_cnt;
	u8 upload_cnt;
} EVENT_UPLOAD_; //¼
///**********************************************************Լ**************************/
#define JIANGE_20_MIN		1	//ü20min
///**********************************************************ϱ״̬************************/
typedef enum{	
	SS_STATE_S0 = 0,
	SS_STATE_S1,
	SS_STATE_S2,
	SS_STATE_S3,
	SS_STATE_S4,
	SS_STATE_S5,
	SS_STATE_S6,
	SS_STATE_S7,
	SS_STATE_S8,
	SS_STATE_S9,
	SS_STATE_S10,
	SS_STATE_S11,
	SS_STATE_S20,
	SS_STATE_S21,
	SS_STATE_S22,
	SS_STATE_S23,
	SS_STATE_S30,
	SS_STATE_S31,
	SS_STATE_S40,
	SS_STATE_WAIT
}TYP_STATE_SS;


typedef enum{
	UPLOAD_S0 = 0,
	UPLOAD_S1,
	UPLOAD_S2
}TYP_MAIN_STATE_UPLOAD;
//涳״̬״̬
enum{
	SAVE_FREEZE_S0 = 0,
	SAVE_FREEZE_S1,
	SAVE_FREEZE_S2,
	SAVE_FREEZE_S3,
	SAVE_FREEZE_S4,
	SAVE_FREEZE_S5,
	SAVE_FREEZE_S6,
	SAVE_FREEZE_S7
};

/**************************************ݲͬԼϱ֡**************************/
u8 NB_SS_Control_GetPara(NB_SS_ControlParaTypeDef paraType);
void NB_SS_Control_SetPara(NB_SS_ControlParaTypeDef paraType, u8 data);

u8 GetEventUploadType(void);
void SystemGetUploadTime(DateTime *pDT);
void SystemProcessor(void);
void SystemProcessorInit(void);
u8 SystemProcessorIfSleep(void);
u8 FixedTimeNbIoTUploadIfIdle(void);
void RtccCheck_Hight_Flow(u8 **addr);
void SysDealAppPreSleep(void);
u8 BleConnectIfIdle(void);

#endif

#endif

