/**
  ******************************************************************************
  * @file    lvd.h
  * @author  (C)2020, Qindao ieslab Co., Ltd
  * @version V1.0
  * @date    2020-7-1
  * @brief   the function of the entity of system processor
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __UWater_LVD_DRIVER_H
#define __UWater_LVD_DRIVER_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "ddl.h"
#include "type.h"


/* MACRO Define---------------------------------------------------------------*/
#define LVD_POW_PORT    	(GpioPortC)
#define LVD_POW_PIN     	(GpioPin13)
#define LVD_SRC           LvdInputSrcMskPC13
	
	
/* variables Define---------------------------------------------------------------*/


/* Function Declare------------------------------------------------------------*/
extern void LVDInit(void);

#ifdef __cplusplus
}
#endif

#endif /* __UWater_UART_DRIVER_H */
